<template>
    <basic-form :id="id" :submittable="submittable" module="Movie" list-route-name="Movies" form-route-name="MovieForm" :get-route="getRoute" :post-route="postRoute" :put-route="getRoute" :form="form" :afterSubmit="onSubmitReceived" success-message="Successfully saved movie!">
        <form-field field="code" label="Title" :form="form">
            <input type="text" v-model="form.title" required id="title" name="title" class="input" :class="{'is-danger': form.errors.has('title')}" />
        </form-field>

        <form-field field="type" label="Genre" :form="form" :is-select="true">
            <select v-model="form.genre" required id="type" name="type" class="is-fullwidth is-small" :class="{'is-danger': form.errors.has('genre')}">
                <option value="">Please Select</option>
                <option v-for="genre in genres" :value="genre.value">{{ genre.label }}</option>
            </select>
        </form-field>

        <form-field field="rating" label="Rating" :form="form">
            <input type="number" v-model="form.rating" max="5" min="1" required id="rating" name="rating" class="input" :class="{'is-danger': form.errors.has('rating')}" />
        </form-field>

        <form-field field="year" label="Year" :form="form">
            <input type="number" v-model="form.year" required id="year" name="year" class="input" :class="{'is-danger': form.errors.has('year')}" />
        </form-field>

        <form-field field="actors" label="Actors" :form="form">
            <div class="is-grouped is-grouped-multiline field">
                <div v-for="(tag, index) in form.actors" class="control add-small-bottom-space">
                    <div class="tags has-addons">
                        <span class="tag is-primary">{{ tag.label }}</span>
                        <span class="tag is-delete" @click="removeActor(index)"></span>
                    </div>
                </div>
            </div>
            <b-auto-complete
                class="is-expanded"
                v-model="text"
                placeholder="Start typing a name"
                :data="options"
                :loading="loading"
                field="label"
                :keep-first="true"
                :open-on-focus="true"
                @input="fetchActors"
                @select="selected"
            >

            </b-auto-complete>
        </form-field>

    </basic-form>
</template>

<script>
    import { Form } from '../components/forms/form';
    import BasicForm from '../components/forms/basic-form';
    import FormField from '../components/forms/form-field';
    import debounce from 'lodash/debounce';
    import actors from '../queryables/actors';
    import BAutoComplete from '../../../../node_modules/buefy/src/components/autocomplete/Autocomplete.vue';
    export default {
        props: ['id'],
        components: {BasicForm, FormField, BAutoComplete},
        data() {
            return {
                form: new Form({
                    title: '',
                    genre: '',
                    rating: 1,
                    year: null,
                    actors:[]
                }),
                text: '',
                postRoute: route('movies.store'),
                options:[],
                loading:false
            }
        },
        computed: {
            submittable() {
                return this.form.title !== ''
                    && this.form.genre !== ''
                    && this.form.rating !== '';
            },
            getRoute() {
                return route('movies.show', {movie:this.$route.params.id});
            },
            genres() {
                return window.genres;
            }
        },
        methods: {
            onSubmitReceived(resp) {
                this.form = new Form(resp.data);
            },
            removeActor(index) {
                this.form.actors = this.form.actors.splice(1, index);
            },
            selected(select) {
                if(select === null) return;

                this.form.actors.push(select);
            },
            fetchActors: debounce(function() {
                if(this.text.length === 0) return;

                this.loading = true;
                actors.queryable(this.text)
                    .then((data) => {
                        this.options = data;
                    })
            }, 300)
        }
    }
</script>